<script setup lang="ts">
const { loggedIn } = useOidcAuth();

const props = defineProps<{
  open: boolean;
  loading: boolean;
}>();

const open = computed({
  get: () => props.open,
  set: (v: boolean) => emit("update:open", v),
});
const loading = computed(() => props.loading);

const emit = defineEmits<{
  (e: "confirm"): void;
  (e: "update:open", v: boolean): void;
}>();
</script>

<template>
  <client-only>
    <v-dialog v-model="open" width="640">
      <template #activator="{ props: dialogProps }">
        <v-icon
          v-if="loggedIn"
          v-bind="dialogProps"
          icon="mdi-trash-can-outline"
        />
      </template>
      <v-banner stacked>
        <template #text>
          <div class="text-body-1">
            Are you sure you want to remove this item permanently?
          </div>
          <div class="pa-4">
            <slot />
          </div>
        </template>
        <template #actions>
          <v-btn
            variant="flat"
            color="error"
            :disabled="loading"
            :loading="loading"
            @click="emit('confirm')"
          >
            Remove permanently
          </v-btn>
          <v-btn class="ml-2" @click="open = false">Cancel</v-btn>
        </template>
      </v-banner>
    </v-dialog>
  </client-only>
</template>
